diff -Nurp '--exclude=.bzr*' tin-2.6.4/src/options_menu.c tin-2.6.5/src/options_menu.c
--- tin-2.6.4/src/options_menu.c	2024-12-22 18:37:13.000000000 +0100
+++ tin-2.6.5/src/options_menu.c	2025-11-17 21:06:58.482553700 +0100
@@ -3,10 +3,10 @@
  *  Module    : options_menu.c
  *  Author    : Michael Bienia <michael@vorlon.ping.de>
  *  Created   : 2004-09-05
- *  Updated   : 2024-12-21
+ *  Updated   : 2025-11-17
  *  Notes     : Split from config.c
  *
- * Copyright (c) 2004-2025 Michael Bienia <michael@vorlon.ping.de>
+ * Copyright (c) 2004-2026 Michael Bienia <michael@vorlon.ping.de>
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -57,6 +57,11 @@
 	} while (0)
 
 #define UPDATE_INT_ATTRIBUTES(opt) do { \
+		scopes[0].attribute->opt = tinrc.opt; \
+		changed |= MISC_OPTS; \
+	} while (0)
+
+#define UPDATE_NUM_ATTRIBUTES(opt) do { \
 		scopes[0].attribute->opt = CAST_BITS(tinrc.opt, opt); \
 		changed |= MISC_OPTS; \
 	} while (0)
@@ -67,6 +72,12 @@
 		changed |= MISC_OPTS; \
 	} while (0)
 
+#define SET_INT_ATTRIBUTE(opt, attr) do { \
+		curr_scope->attribute->opt = attr; \
+		curr_scope->state->opt = TRUE; \
+		changed |= MISC_OPTS; \
+	} while (0)
+
 #define SET_NUM_ATTRIBUTE(opt, attr) do { \
 		curr_scope->attribute->opt = CAST_BITS(attr, opt); \
 		curr_scope->state->opt = TRUE; \
@@ -120,6 +131,7 @@
 	} while (0)
 
 static enum option_enum first_option_on_screen, last_option_on_screen, last_opt;
+static enum menu_type menu_type = options_menu;
 
 /*
  * local prototypes
@@ -135,6 +147,9 @@ static int add_new_scope(void);
 static int find_scope(const char *scope);
 static int get_option_num(enum option_enum option);
 static int move_scope(int curr_pos);
+#if defined(MULTIBYTE_ABLE) && !defined(NO_LOCALE)
+	static int get_scope_mark_width(void);
+#endif /* MULTIBYTE_ABLE && !NO_LOCALE */
 static t_bool check_state(enum option_enum option);
 static t_bool delete_scope(int curr_pos);
 static t_bool option_is_title(enum option_enum option);
@@ -205,7 +220,7 @@ get_option_num(
 	enum option_enum i;
 	int result = 0;
 
-	for (i = 0; i < option && result < (int) last_opt; i = next_option(i, FALSE))
+	for (i = FIRST_OPT; i < option && result < (int) last_opt; i = next_option(i, FALSE))
 		++result;
 
 	return result;
@@ -219,7 +234,7 @@ static enum option_enum
 set_option_num(
 	int num)
 {
-	enum option_enum result = 0;
+	enum option_enum result = FIRST_OPT;
 
 	while (num > 0 && result < last_opt) {
 		result = next_option(result, FALSE);
@@ -279,6 +294,25 @@ option_is_visible(
 	enum option_enum option)
 {
 	switch (option) {
+		case OPT_SERVERRC_ADD_CMD_LINE_OPTS:
+		case OPT_SERVERRC_DISABLED_NNTP_CMDS:
+		case OPT_SERVERRC_NNTP_PIPELINE_LIMIT:
+		case OPT_SERVERRC_CACHE_OVERVIEW_FILES:
+		case OPT_SERVERRC_TINRC_OVERRIDE_OPTIONS:
+		case OPT_SERVERRC_CONFIG_OPTIONS:
+			return menu_type == serverrc_menu ? TRUE : FALSE;
+
+#	ifdef USE_ZLIB
+		case OPT_SERVERRC_COMPRESS_OVERVIEW_FILES:
+			return menu_type == serverrc_menu && tinrc.serverrc_cache_overview_files ? TRUE : FALSE;
+#	endif /* USE_ZLIB */
+
+		default:
+			if (menu_type == serverrc_menu)
+				return FALSE;
+	}
+
+	switch (option) {
 #ifdef HAVE_COLOR
 		case OPT_COL_BACK:
 		case OPT_COL_FROM:
@@ -315,16 +349,16 @@ option_is_visible(
 			return curr_scope ? FALSE : (tinrc.word_highlight && tinrc.use_color);
 
 		case OPT_COL_VERBATIM:
-			return curr_scope ? FALSE : (tinrc.verbatim_handling && tinrc.use_color);
+			return curr_scope ? FALSE : (tinrc.verbatim_handling > 0 && tinrc.use_color);
 
 		case OPT_EXTQUOTE_REGEX:
 			return curr_scope ? FALSE : (tinrc.extquote_handling && tinrc.use_color);
 #endif /* HAVE_COLOR */
 
-#if defined(USE_ZLIB) && defined(CPP_DOES_CONCAT)
+#ifdef USE_ZLIB
 		case OPT_COMPRESS_OVERVIEW_FILES:
 			return curr_scope ? FALSE : tinrc.cache_overview_files;
-#endif /* USE_ZLIB && CPP_DOES_CONCAT */
+#endif /* USE_ZLIB */
 
 		case OPT_WORD_H_DISPLAY_MARKS:
 		case OPT_SLASHES_REGEX:
@@ -350,13 +384,12 @@ option_is_visible(
 
 		case OPT_VERBATIM_BEGIN_REGEX:
 		case OPT_VERBATIM_END_REGEX:
-			return curr_scope ? FALSE : tinrc.verbatim_handling;
+			return curr_scope ? FALSE : tinrc.verbatim_handling > 0;
 
 #ifndef USE_CURSES
 		case OPT_STRIP_BLANKS:
-#endif /* !USE_CURSES */
-		case OPT_GETART_LIMIT_OPTIONS:
 			return curr_scope ? FALSE : TRUE;
+#endif /* !USE_CURSES */
 
 #ifdef HAVE_COLOR
 		case OPT_COLOR_OPTIONS:
@@ -365,6 +398,7 @@ option_is_visible(
 
 		case OPT_DISPLAY_OPTIONS:
 		case OPT_FILTERING_OPTIONS:
+		case OPT_GETART_LIMIT_OPTIONS:
 		case OPT_SAVING_OPTIONS:
 		case OPT_POSTING_OPTIONS:
 		case OPT_EXPERT_OPTIONS:
@@ -384,8 +418,10 @@ option_is_visible(
 		case OPT_ATTRIB_FCC:
 		case OPT_ATTRIB_FOLLOWUP_TO:
 		case OPT_ATTRIB_FROM:
+		case OPT_ATTRIB_GETART_LIMIT:
 		case OPT_ATTRIB_GROUP_CATCHUP_ON_EXIT:
 		case OPT_ATTRIB_GROUP_FORMAT:
+		case OPT_ATTRIB_HIDE_INLINE_DATA:
 #ifdef HAVE_ISPELL
 		case OPT_ATTRIB_ISPELL:
 #endif /* HAVE_ISPELL */
@@ -459,6 +495,9 @@ option_is_visible(
 			return curr_scope ? tinrc.use_color : FALSE;
 #endif /* HAVE_COLOR */
 
+		case SIGNAL_HANDLER:
+			return FALSE;
+
 		default:
 			return curr_scope ? FALSE : TRUE;
 	}
@@ -495,57 +534,22 @@ fmt_option_prompt(
 	enum option_enum option)
 {
 	char *buf;
-	size_t option_width = (size_t) MAX(35, cCOLS / 2 - 9);
-#if defined(MULTIBYTE_ABLE) && !defined(NO_LOCALE)
-	wchar_t *wbuf, *wbuf2;
-
-	/* convert the option text to wchar_t */
-	wbuf = char2wchar_t(_(option_table[option].txt->opt));
-#endif /* MULTIBYTE_ABLE && !NO_LOCALE */
-
 	if (!option_is_title(option)) {
 		char flag;
-		int num = get_option_num(option);
+		int opt_len, num = get_option_num(option);
+		size_t option_width = (size_t) MAX(25, cCOLS / 2 - 5);
 
 		flag = (curr_scope && check_state(option)) ? '+' : ' ';
-#if defined(MULTIBYTE_ABLE) && !defined(NO_LOCALE)
-		if (wbuf != NULL) {
-			wbuf2 = wstrunc(wbuf, option_width);
-			if ((buf = wchar_t2char(wbuf2)) == NULL) {
-				/* conversion failed, truncate original string */
-				buf = strunc(_(option_table[option].txt->opt), option_width);
-				snprintf(dst, len, "%s %c%3d %-*.*s: ", editing ? "->" : "  ", flag, num, (int) option_width, (int) option_width, buf);
-			} else
-				snprintf(dst, len, "%s %c%3d %-*.*s: ", editing ? "->" : "  ", flag, num,
-					(int) (strlen(buf) + option_width - (size_t) wcswidth(wbuf2, option_width + 1)),
-					(int) (strlen(buf) + option_width - (size_t) wcswidth(wbuf2, option_width + 1)), buf);
-			free(wbuf2);
-		} else
-#endif /* MULTIBYTE_ABLE && !NO_LOCALE */
-		{
-			/* truncate original string */
-			buf = strunc(_(option_table[option].txt->opt), option_width);
-			snprintf(dst, len, "%s %c%3d %-*.*s: ", editing ? "->" : "  ", flag, num, (int) option_width, (int) option_width, buf);
-		}
+		buf = strunc(_(option_table[option].txt->opt), option_width);
+		opt_len = (int) (strlen(buf) + option_width - strwidth(buf));
+		snprintf(dst, len, "%s %c%3d %-*.*s: ", editing ? "->" : "  ", flag, num, opt_len, opt_len, buf);
 	} else {
 		size_t w = (size_t) (cCOLS > 3 ? cCOLS - 3 : 0);
 
-#if defined(MULTIBYTE_ABLE) && !defined(NO_LOCALE)
-		if (wbuf != NULL) {
-			wbuf2 = wstrunc(wbuf, w);
-			if ((buf = wchar_t2char(wbuf2)) == NULL)	/* conversion failed, truncate original string */
-				buf = strunc(_(option_table[option].txt->opt), w);
-			free(wbuf2);
-		} else
-#endif /* MULTIBYTE_ABLE && !NO_LOCALE */
-			buf = strunc(_(option_table[option].txt->opt), w);	/* truncate original string */
+		buf = strunc(_(option_table[option].txt->opt), w);
 		snprintf(dst, len, "  %s", buf);
 	}
-
-#if defined(MULTIBYTE_ABLE) && !defined(NO_LOCALE)
-	FreeIfNeeded(wbuf);
-#endif /* MULTIBYTE_ABLE && !NO_LOCALE */
-	FreeIfNeeded(buf);
+	free(buf);
 	return dst;
 }
 
@@ -590,12 +594,14 @@ print_any_option(
 			break;
 
 		case OPT_CHAR:
-			snprintf(ptr, len, "%"T_CHAR_FMT, (wint_t) *OPT_CHAR_list[option_table[option].var_index]);
+			snprintf(ptr, len, "%"T_CHAR_FMT, (T_CHAR_TYPE) *OPT_CHAR_list[option_table[option].var_index]);
 			break;
 
 		default:
 			break;
 	}
+	if (option == OPT_HIDELINE_REGEX && STRCMPEQ(ptr, NEVER_MATCH_REGEX))
+		*ptr = '\0';
 #ifdef USE_CURSES
 #	if defined(MULTIBYTE_ABLE) && !defined(NO_LOCALE)
 	if ((buf = spart(temp, (size_t) (cCOLS > 1 ? cCOLS - 1 : 0), FALSE)) != NULL) {
@@ -788,7 +794,7 @@ next_option(
 	do {
 		++option;
 		if (option > last_opt)
-			option = 0;
+			option = FIRST_OPT;
 	} while (!(option_is_visible(option) && (incl_titles || !option_is_title(option))));
 
 	return option;
@@ -805,7 +811,7 @@ prev_option(
 	t_bool incl_titles)
 {
 	do {
-		if (option == 0)
+		if (option == FIRST_OPT)
 			option = last_opt;
 		else
 			--option;
@@ -832,8 +838,8 @@ set_first_option_on_screen(
 	/*
 	 * make sure that the first page is used completely
 	 */
-	if (first_option_on_screen == 0)
-		set_last_option_on_screen(0);
+	if (first_option_on_screen == FIRST_OPT)
+		set_last_option_on_screen(FIRST_OPT);
 }
 
 
@@ -862,7 +868,8 @@ highlight_option(
 {
 	refresh_config_page(option); /* to keep refresh_config_page():last_option up-to-date */
 	draw_arrow_mark(option_row(option));
-	info_message("%s", _(option_table[option].txt->opt));
+	if (tinrc.info_in_last_line)
+		info_message("%s", _(option_table[option].txt->opt));
 }
 
 
@@ -891,7 +898,7 @@ void
 refresh_config_page(
 	enum option_enum act_option)
 {
-	static enum option_enum last_option = 0;
+	static enum option_enum last_option = FIRST_OPT;
 	/* t_bool force_redraw = FALSE; */
 
 	if (act_option == SIGNAL_HANDLER) {	/* called by signal handler */
@@ -938,12 +945,13 @@ show_config_page(
 	void)
 {
 	enum option_enum i;
+	int prev_mark_offset = mark_offset;
 
 	signal_context = curr_scope ? cAttrib : cConfig;
 	mark_offset = 0;
 
 	ClearScreen();
-	center_line(0, TRUE, curr_scope ? curr_scope->scope : _(txt_options_menu));
+	center_line(0, TRUE, menu_type == serverrc_menu ? _(txt_serverrc_menu) : curr_scope ? curr_scope->scope : _(txt_options_menu));
 
 	for (i = first_option_on_screen; i <= last_option_on_screen; i++) {
 		while (!option_is_visible(i))
@@ -956,6 +964,7 @@ show_config_page(
 	show_menu_help(txt_select_config_file_option);
 	my_flush();
 	stow_cursor();
+	mark_offset = prev_mark_offset;
 }
 
 
@@ -999,7 +1008,7 @@ set_last_opt(
 {
 	enum option_enum i;
 
-	for (i = 0; i <= LAST_OPT; i++) {
+	for (i = FIRST_OPT; i <= LAST_OPT; i++) {
 		if (option_is_visible(i))
 			last_opt = i;
 	}
@@ -1015,7 +1024,7 @@ get_first_opt(
 {
 	enum option_enum i;
 
-	for (i = 0; i <= last_opt; i++) {
+	for (i = FIRST_OPT; i <= last_opt; i++) {
 		if (option_is_visible(i) && !option_is_title(i))
 			break;
 	}
@@ -1043,10 +1052,11 @@ config_page(
 		SORT_OPTS			= 1 << 5,
 		THREAD_ARTS			= 1 << 6,
 		THREAD_SCORE		= 1 << 7,
-		TEX2ISO_CONV		= 1 << 8
+		TEX2ISO_CONV		= 1 << 8,
+		HIDE_INLINE_DATA	= 1 << 9
 	} changed = NOT_CHANGED;
 	int i, scope_idx = 0;
-	int prev_signal_context = signal_context;
+	enum context prev_signal_context = signal_context;
 	t_bool change_option = FALSE;
 	t_function func;
 #ifdef CHARSET_CONVERSION
@@ -1054,6 +1064,7 @@ config_page(
 #endif /* CHARSET_CONVERSION */
 	unsigned old_show_author = 0, old_show_unread = 0, old_thread_arts = 0;
 
+	menu_type = options_menu;
 	if (curr_scope)
 		initialize_attributes();
 	if (grpname && curr_group) {
@@ -1068,8 +1079,8 @@ config_page(
 	}
 	set_last_opt();
 	option = get_first_opt();
-	first_option_on_screen = 0;
-	set_last_option_on_screen(0);
+	first_option_on_screen = FIRST_OPT;
+	set_last_option_on_screen(FIRST_OPT);
 
 	redraw_screen(option);
 	set_xclick_off();
@@ -1077,6 +1088,15 @@ config_page(
 	forever {
 		switch ((func = handle_keypad(option_left, option_right, NULL, option_menu_keys))) {
 			case GLOBAL_QUIT:
+				if (menu_type == serverrc_menu) {
+					menu_type = options_menu;
+					set_last_opt();
+					option = get_first_opt();
+					first_option_on_screen = FIRST_OPT;
+					set_last_option_on_screen(FIRST_OPT);
+					redraw_screen(option);
+					break;
+				}
 				if (grpname) {
 					if (curr_scope && scope_is_empty()) {
 						/*
@@ -1097,6 +1117,15 @@ config_page(
 				}
 				/* FALLTHROUGH */
 			case CONFIG_NO_SAVE:
+				if (menu_type == serverrc_menu) {
+					menu_type = options_menu;
+					set_last_opt();
+					option = get_first_opt();
+					first_option_on_screen = FIRST_OPT;
+					set_last_option_on_screen(FIRST_OPT);
+					redraw_screen(option);
+					break;
+				}
 				if (grpname && curr_scope) {
 					/*
 					 * Called via TAB from Config 'M'enu,
@@ -1110,7 +1139,8 @@ config_page(
 				}
 				if (curr_scope)
 					free_tinrc_attributes();
-				assign_attributes_to_groups();
+				if (changed)
+					assign_attributes_to_groups();
 				if (grpname && curr_group) {
 					/*
 					 * These things can be toggled by the user,
@@ -1133,7 +1163,7 @@ config_page(
 						if (changed & TEX2ISO_CONV) {
 							if (pgart.raw) {
 								if (curr_group->attribute->tex2iso_conv)
-									pgart.tex2iso = is_art_tex_encoded(pgart.raw);
+									;
 								else
 									pgart.tex2iso = FALSE;
 								/* force recooking the current article */
@@ -1144,8 +1174,11 @@ config_page(
 						 * recook if an article is open
 						 */
 						if (changed & DISPLAY_OPTS) {
-							if (pgart.raw)
+							if (pgart.raw) {
+								if (changed & HIDE_INLINE_DATA)
+									update_hide_inline_data();
 								resize_article(TRUE, &pgart);
+							}
 						}
 						/*
 						 * Clear art->keep_in_base if switching to !show_only_unread_arts
@@ -1157,8 +1190,8 @@ config_page(
 
 						if (changed & SCORE_OPTS) {
 							unfilter_articles(curr_group);
-							read_filter_file(filter_file);
-							filtered = filter_articles(curr_group);
+							if (read_filter_file(filter_file))
+								filtered = filter_articles(curr_group);
 						}
 						/*
 						 * If the sorting/threading strategy of threads or filter options have
@@ -1198,11 +1231,18 @@ config_page(
 			case GLOBAL_HELP:
 				if (curr_scope)
 					show_help_page(ATTRIB_LEVEL, _(txt_attrib_menu_com));
+				else if (menu_type == serverrc_menu)
+					show_help_page(SERVERRC_LEVEL, _(txt_serverrc_menu_com));
 				else
 					show_help_page(CONFIG_LEVEL, _(txt_options_menu_com));
 				redraw_screen(option);
 				break;
 
+			case GLOBAL_CONNECTION_INFO:
+				show_connection_page();
+				redraw_screen(option);
+				break;
+
 			case GLOBAL_LINE_UP:
 				unhighlight_option(option);
 				option = move_cursor(option, FALSE);
@@ -1218,8 +1258,8 @@ config_page(
 			case GLOBAL_FIRST_PAGE:
 				unhighlight_option(option);
 				option = get_first_opt();
-				first_option_on_screen = 0;
-				set_last_option_on_screen(0);
+				first_option_on_screen = FIRST_OPT;
+				set_last_option_on_screen(FIRST_OPT);
 				redraw_screen(option);
 				/* highlight_option(option); is already done by redraw_screen() */
 				break;
@@ -1241,7 +1281,7 @@ config_page(
 						option = next_option(option, FALSE);
 					highlight_option(option);
 					break;
-				} else if (tinrc.scroll_lines == -2 && first_option_on_screen != 0) {
+				} else if (tinrc.scroll_lines == -2 && first_option_on_screen != FIRST_OPT) {
 					i = option_lines_per_page / 2;
 
 					for (; i > 0; i--) {
@@ -1267,8 +1307,8 @@ config_page(
 				unhighlight_option(option);
 				if (option == last_opt) {
 					/* wrap around */
-					first_option_on_screen = 0;
-					option = 0;
+					first_option_on_screen = FIRST_OPT;
+					option = FIRST_OPT;
 				} else {
 					enum option_enum old_first = first_option_on_screen;
 
@@ -1277,13 +1317,13 @@ config_page(
 
 						for (; i > 0; i--) {
 							first_option_on_screen = next_option(first_option_on_screen, TRUE);
-							if (first_option_on_screen == 0)	/* end on wrap_around */
+							if (first_option_on_screen == FIRST_OPT)	/* end on wrap_around */
 								break;
 						}
 					} else
 						first_option_on_screen = next_option(last_option_on_screen, TRUE);
 
-					if (first_option_on_screen == 0) {
+					if (first_option_on_screen == FIRST_OPT) {
 						first_option_on_screen = old_first;
 						option = last_opt;
 						highlight_option(option);
@@ -1354,14 +1394,37 @@ config_page(
 				break;
 
 			case CONFIG_SCOPE_MENU:
-				if (!curr_scope) {
-					scope_page(level);
+				if (menu_type == options_menu) {
+					if (!curr_scope) {
+						scope_page(level);
+						set_last_opt();
+						option = get_first_opt();
+						first_option_on_screen = FIRST_OPT;
+						set_last_option_on_screen(FIRST_OPT);
+						redraw_screen(option);
+					}
+				} else
+					/*
+					 * CONFIG_SCOPE_MENU is valid in serverrc_menu but we allow
+					 * it only in options_menu hence the 'bad command' message
+					 */
+					info_message(_(txt_bad_command), PrintFuncKey(key, GLOBAL_HELP, option_menu_keys));
+				break;
+
+			case CONFIG_SERVERRC_MENU:
+				if (menu_type == options_menu) {
+					menu_type = serverrc_menu;
 					set_last_opt();
 					option = get_first_opt();
-					first_option_on_screen = 0;
-					set_last_option_on_screen(0);
+					first_option_on_screen = FIRST_OPT;
+					set_last_option_on_screen(FIRST_OPT);
 					redraw_screen(option);
-				}
+				} else
+					/*
+					 * CONFIG_SERVERRC_MENU is valid in serverrc_menu but we allow
+					 * it only in options_menu hence the 'bad command' message
+					 */
+					info_message(_(txt_bad_command), PrintFuncKey(key, GLOBAL_HELP, option_menu_keys));
 				break;
 
 			case CONFIG_RESET_ATTRIB:
@@ -1384,7 +1447,7 @@ config_page(
 				break;
 
 			case CONFIG_TOGGLE_ATTRIB:
-				if (grpname) {
+				if (menu_type != serverrc_menu && grpname) {
 					if (curr_scope) {
 						if (scope_is_empty()) {
 							do_delete_scope(scope_idx);
@@ -1401,8 +1464,8 @@ config_page(
 					}
 					set_last_opt();
 					option = get_first_opt();
-					first_option_on_screen = 0;
-					set_last_option_on_screen(0);
+					first_option_on_screen = FIRST_OPT;
+					set_last_option_on_screen(FIRST_OPT);
 					redraw_screen(option);
 				}
 				break;
@@ -1427,6 +1490,12 @@ config_page(
 				break;
 #endif /* HAVE_COLOR */
 
+			case GLOBAL_TOGGLE_INFO_LAST_LINE:
+				tinrc.info_in_last_line = bool_not(tinrc.info_in_last_line);
+				clear_message();
+				highlight_option(option);
+				break;
+
 			default:
 				info_message(_(txt_bad_command), PrintFuncKey(key, GLOBAL_HELP, option_menu_keys));
 				break;
@@ -1437,11 +1506,10 @@ config_page(
 				case OPT_ON_OFF:
 					switch (option) {
 						case OPT_ABBREVIATE_GROUPNAME:
+#ifdef NNTP_ABLE
 						case OPT_AUTO_RECONNECT:
+#endif /* NNTP_ABLE */
 						case OPT_CATCHUP_READ_GROUPS:
-#if defined(USE_ZLIB) && defined(CPP_DOES_CONCAT)
-						case OPT_COMPRESS_OVERVIEW_FILES:
-#endif /* USE_ZLIB && CPP_DOES_CONCAT */
 						case OPT_FORCE_SCREEN_REDRAW:
 						case OPT_KEEP_DEAD_ARTICLES:
 						case OPT_SHOW_ONLY_UNREAD_GROUPS:
@@ -1467,6 +1535,15 @@ config_page(
 								UPDATE_BOOL_ATTRIBUTES(add_posted_to_filter);
 							break;
 
+						case OPT_KEEP_EXPIRED_FILTERS:
+							if (prompt_option_on_off(option)) {
+#if 0 /* TODO: desired? or defer till end of session so one could undo it before */
+								if (!tinrc.keep_expired_filters)
+									write_filter_file(filter_file);
+#endif /* 0 */
+							}
+							break;
+
 						case OPT_ADVERTISING:
 							if (prompt_option_on_off(option))
 								UPDATE_BOOL_ATTRIBUTES(advertising);
@@ -1501,13 +1578,21 @@ config_page(
 							 */
 							if (prompt_option_on_off(option)) {
 								changed |= MISC_OPTS;
-#if defined(USE_ZLIB) && defined(CPP_DOES_CONCAT)
+#ifdef USE_ZLIB
 								set_last_option_on_screen(first_option_on_screen);
 								redraw_screen(option);
-#endif /* USE_ZLIB && CPP_DOES_CONCAT */
+#endif /* USE_ZLIB */
+								serverrc.cache_overview_files = tinrc.cache_overview_files;
 							}
 							break;
 
+#ifdef USE_ZLIB
+						case OPT_COMPRESS_OVERVIEW_FILES:
+							if (prompt_option_on_off(option))
+								serverrc.compress_overview_files = tinrc.compress_overview_files;
+							break;
+#endif /* USE_ZLIB */
+
 #ifdef HAVE_COLOR
 						case OPT_EXTQUOTE_HANDLING:
 							/*
@@ -1629,19 +1714,6 @@ config_page(
 								UPDATE_BOOL_ATTRIBUTES(wrap_on_next_unread);
 							break;
 
-						case OPT_VERBATIM_HANDLING:
-							/*
-							 * option toggles visibility of other
-							 * options -> needs redraw_screen()
-							 */
-							if (prompt_option_on_off(option)) {
-								UPDATE_BOOL_ATTRIBUTES(verbatim_handling);
-								set_last_option_on_screen(first_option_on_screen);
-								redraw_screen(option);
-								changed |= DISPLAY_OPTS;
-							}
-							break;
-
 						/* show mini help menu */
 						case OPT_BEGINNER_LEVEL:
 							if (prompt_option_on_off(option)) {
@@ -1713,6 +1785,7 @@ config_page(
 							if (prompt_option_on_off(option)) {
 								if ((show_description = tinrc.show_description)) /* force reread of newgroups file */
 									read_descriptions(FALSE);
+								need_parse_fmt |= SELECT_LEVEL;
 								changed |= MISC_OPTS;
 							}
 							break;
@@ -1951,13 +2024,6 @@ config_page(
 							break;
 #endif /* CHARSET_CONVERSION && USE_ICU_UCSDET */
 
-						case OPT_ATTRIB_VERBATIM_HANDLING:
-							if (prompt_option_on_off(option)) {
-								SET_BOOL_ATTRIBUTE(verbatim_handling, tinrc.attrib_verbatim_handling);
-								changed |= DISPLAY_OPTS;
-							}
-							break;
-
 						case OPT_ATTRIB_WRAP_ON_NEXT_UNREAD:
 							if (prompt_option_on_off(option))
 								SET_BOOL_ATTRIBUTE(wrap_on_next_unread, tinrc.attrib_wrap_on_next_unread);
@@ -1968,6 +2034,24 @@ config_page(
 								SET_BOOL_ATTRIBUTE(x_comment_to, tinrc.attrib_x_comment_to);
 							break;
 
+						case OPT_SERVERRC_CACHE_OVERVIEW_FILES:
+							if (prompt_option_on_off(option)) {
+#ifdef USE_ZLIB
+								set_last_opt();
+								set_last_option_on_screen(first_option_on_screen);
+								redraw_screen(option);
+#endif /* USE_ZLIB */
+								serverrc.cache_overview_files = tinrc.serverrc_cache_overview_files;
+							}
+							break;
+
+#ifdef USE_ZLIB
+						case OPT_SERVERRC_COMPRESS_OVERVIEW_FILES:
+							if (prompt_option_on_off(option))
+								serverrc.compress_overview_files = tinrc.serverrc_compress_overview_files;
+							break;
+#endif /* USE_ZLIB */
+
 						default:
 							break;
 					} /* switch (option) */
@@ -1982,8 +2066,6 @@ config_page(
 						case OPT_COL_FROM:
 						case OPT_COL_HEAD:
 						case OPT_COL_HELP:
-						case OPT_COL_INVERS_BG:
-						case OPT_COL_INVERS_FG:
 						case OPT_COL_MESSAGE:
 						case OPT_COL_MINIHELP:
 						case OPT_COL_NEWSHEADERS:
@@ -2032,6 +2114,8 @@ config_page(
 #ifdef HAVE_COLOR
 						case OPT_COL_BACK:
 						case OPT_COL_NORMAL:
+						case OPT_COL_INVERS_BG:
+						case OPT_COL_INVERS_FG:
 							if (prompt_option_list(option)) {
 								redraw_screen(option);
 								changed |= MISC_OPTS;
@@ -2041,33 +2125,34 @@ config_page(
 
 						case OPT_AUTO_CC_BCC:
 							if (prompt_option_list(option))
-								UPDATE_INT_ATTRIBUTES(auto_cc_bcc);
+								UPDATE_NUM_ATTRIBUTES(auto_cc_bcc);
 							break;
 
-						case OPT_HIDE_UUE:
+						case OPT_HIDE_INLINE_DATA:
 							if (prompt_option_list(option)) {
-								update_hide_uue();
+								UPDATE_NUM_ATTRIBUTES(hide_inline_data);
+								changed |= HIDE_INLINE_DATA;
 								changed |= DISPLAY_OPTS;
 							}
 							break;
 
 						case OPT_THREAD_ARTICLES:
 							if (prompt_option_list(option)) {
-								UPDATE_INT_ATTRIBUTES(thread_articles);
+								UPDATE_NUM_ATTRIBUTES(thread_articles);
 								changed |= THREAD_ARTS;
 							}
 							break;
 
 						case OPT_SORT_ARTICLE_TYPE:
 							if (prompt_option_list(option)) {
-								UPDATE_INT_ATTRIBUTES(sort_article_type);
+								UPDATE_NUM_ATTRIBUTES(sort_article_type);
 								changed |= SORT_OPTS;
 							}
 							break;
 
 						case OPT_SORT_THREADS_TYPE:
 							if (prompt_option_list(option)) {
-								UPDATE_INT_ATTRIBUTES(sort_threads_type);
+								UPDATE_NUM_ATTRIBUTES(sort_threads_type);
 								changed |= SORT_OPTS;
 							}
 							break;
@@ -2079,19 +2164,32 @@ config_page(
 
 						case OPT_TRIM_ARTICLE_BODY:
 							if (prompt_option_list(option)) {
-								UPDATE_INT_ATTRIBUTES(trim_article_body);
+								UPDATE_NUM_ATTRIBUTES(trim_article_body);
+								changed |= DISPLAY_OPTS;
+							}
+							break;
+
+						case OPT_VERBATIM_HANDLING:
+							/*
+							 * option toggles visibility of other
+							 * options -> needs redraw_screen()
+							 */
+							if (prompt_option_list(option)) {
+								UPDATE_NUM_ATTRIBUTES(verbatim_handling);
+								set_last_option_on_screen(first_option_on_screen);
+								redraw_screen(option);
 								changed |= DISPLAY_OPTS;
 							}
 							break;
 
 						case OPT_POST_PROCESS_TYPE:
 							if (prompt_option_list(option))
-								UPDATE_INT_ATTRIBUTES(post_process_type);
+								UPDATE_NUM_ATTRIBUTES(post_process_type);
 							break;
 
 						case OPT_SHOW_AUTHOR:
 							if (prompt_option_list(option)) {
-								UPDATE_INT_ATTRIBUTES(show_author);
+								UPDATE_NUM_ATTRIBUTES(show_author);
 								changed |= SHOW_AUTHOR;
 							}
 							break;
@@ -2122,8 +2220,9 @@ config_page(
 									}
 								}
 #endif /* CHARSET_CONVERSION */
-								UPDATE_INT_ATTRIBUTES(mail_mime_encoding);
-								/* do not use 8 bit headers if mime encoding is not 8bit */
+								UPDATE_NUM_ATTRIBUTES(mail_mime_encoding);
+								/* do not use 8 bit headers in email if mime encoding is not 8bit */
+								/* coverity[copy_paste_error:SUPPRESS] */
 								if (tinrc.mail_mime_encoding != MIME_ENCODING_8BIT) {
 									tinrc.mail_8bit_header = FALSE;
 									repaint_option(OPT_MAIL_8BIT_HEADER);
@@ -2158,8 +2257,8 @@ config_page(
 									}
 								}
 #endif /* CHARSET_CONVERSION */
-								UPDATE_INT_ATTRIBUTES(post_mime_encoding);
-								/* do not use 8 bit headers if mime encoding is not 8bit */
+								UPDATE_NUM_ATTRIBUTES(post_mime_encoding);
+								/* do not use 8 bit headers in articles if mime encoding is not 8bit */
 								if (tinrc.post_mime_encoding != MIME_ENCODING_8BIT) {
 									tinrc.post_8bit_header = FALSE;
 									repaint_option(OPT_POST_8BIT_HEADER);
@@ -2178,7 +2277,7 @@ config_page(
 								 * if (mail|post)_mime_encoding != 8bit, disable (mail|post)_8bit_header
 								 */
 								is_7bit = FALSE;
-								UPDATE_INT_ATTRIBUTES(mm_network_charset);
+								UPDATE_NUM_ATTRIBUTES(mm_network_charset);
 								for (i = 0; txt_mime_7bit_charsets[i] != NULL; i++) {
 									if (!strcasecmp(txt_mime_charsets[tinrc.mm_network_charset], txt_mime_7bit_charsets[i])) {
 										is_7bit = TRUE;
@@ -2191,7 +2290,7 @@ config_page(
 										tinrc.mail_8bit_header = FALSE;
 										repaint_option(OPT_MAIL_MIME_ENCODING);
 										repaint_option(OPT_MAIL_8BIT_HEADER);
-										UPDATE_INT_ATTRIBUTES(mail_mime_encoding);
+										UPDATE_NUM_ATTRIBUTES(mail_mime_encoding);
 										UPDATE_BOOL_ATTRIBUTES(mail_8bit_header);
 									}
 									if (tinrc.post_mime_encoding != MIME_ENCODING_7BIT) {
@@ -2199,19 +2298,19 @@ config_page(
 										tinrc.post_8bit_header = FALSE;
 										repaint_option(OPT_POST_MIME_ENCODING);
 										repaint_option(OPT_POST_8BIT_HEADER);
-										UPDATE_INT_ATTRIBUTES(post_mime_encoding);
+										UPDATE_NUM_ATTRIBUTES(post_mime_encoding);
 										UPDATE_BOOL_ATTRIBUTES(post_8bit_header);
 									}
 								} else {
 									if (tinrc.mail_mime_encoding == MIME_ENCODING_7BIT) {
 										tinrc.mail_mime_encoding = MIME_ENCODING_QP;
 										repaint_option(OPT_MAIL_MIME_ENCODING);
-										UPDATE_INT_ATTRIBUTES(mail_mime_encoding);
+										UPDATE_NUM_ATTRIBUTES(mail_mime_encoding);
 									}
 									if (tinrc.post_mime_encoding == MIME_ENCODING_7BIT) {
 										tinrc.post_mime_encoding = MIME_ENCODING_8BIT;
 										repaint_option(OPT_POST_MIME_ENCODING);
-										UPDATE_INT_ATTRIBUTES(post_mime_encoding);
+										UPDATE_NUM_ATTRIBUTES(post_mime_encoding);
 									}
 								}
 							}
@@ -2223,6 +2322,14 @@ config_page(
 								SET_NUM_ATTRIBUTE(auto_cc_bcc, tinrc.attrib_auto_cc_bcc);
 							break;
 
+						case OPT_ATTRIB_HIDE_INLINE_DATA:
+							if (prompt_option_list(option)) {
+								SET_NUM_ATTRIBUTE(hide_inline_data, tinrc.attrib_hide_inline_data);
+								changed |= HIDE_INLINE_DATA;
+								changed |= DISPLAY_OPTS;
+							}
+							break;
+
 						case OPT_ATTRIB_MAIL_MIME_ENCODING:
 							if (prompt_option_list(option))
 								SET_NUM_ATTRIBUTE(mail_mime_encoding, tinrc.attrib_mail_mime_encoding);
@@ -2290,6 +2397,13 @@ config_page(
 							}
 							break;
 
+						case OPT_ATTRIB_VERBATIM_HANDLING:
+							if (prompt_option_list(option)) {
+								SET_NUM_ATTRIBUTE(verbatim_handling, tinrc.attrib_verbatim_handling);
+								changed |= DISPLAY_OPTS;
+							}
+							break;
+
 						default:
 							break;
 					} /* switch (option) */
@@ -2519,13 +2633,11 @@ config_page(
 							if (prompt_option_string(option)) {
 								regex_cache_destroy(&strip_was_regex);
 								if (!*tinrc.strip_was_regex) {
-									if (regex_use_utf8()) {
-										free(tinrc.strip_was_regex);
+									free(tinrc.strip_was_regex);
+									if (regex_use_utf8())
 										tinrc.strip_was_regex = my_strdup(DEFAULT_U8_STRIP_WAS_REGEX);
-									} else {
-										free(tinrc.strip_was_regex);
+									else
 										tinrc.strip_was_regex = my_strdup(DEFAULT_STRIP_WAS_REGEX);
-									}
 								}
 								compile_regex(tinrc.strip_was_regex, &strip_was_regex, 0);
 								changed |= MISC_OPTS;
@@ -2556,6 +2668,20 @@ config_page(
 							}
 							break;
 
+						case OPT_HIDELINE_REGEX:
+							if (STRCMPEQ(tinrc.hideline_regex, NEVER_MATCH_REGEX)) /* hide internal NEVER_MATCH_REGEX from user */
+								*tinrc.hideline_regex = '\0';
+							if (prompt_option_string(option)) {
+								regex_cache_destroy(&hideline_regex);
+								if (!*tinrc.hideline_regex) {
+									free(tinrc.hideline_regex);
+									tinrc.hideline_regex = my_strdup(NEVER_MATCH_REGEX);
+								}
+								compile_regex(tinrc.hideline_regex, &hideline_regex, 0);
+								changed |= DISPLAY_OPTS;
+							}
+							break;
+
 						case OPT_ATTACHMENT_FORMAT:
 							if (prompt_option_string(option)) {
 								if (!*tinrc.attachment_format) {
@@ -2604,6 +2730,16 @@ config_page(
 							}
 							break;
 
+						case OPT_PAGE_YENC_FORMAT:
+							if (prompt_option_string(option)) {
+								if (!*tinrc.page_yenc_format) {
+									free(tinrc.page_yenc_format);
+									tinrc.page_yenc_format = my_strdup(DEFAULT_PAGE_YENC_FORMAT);
+								}
+								changed |= DISPLAY_OPTS;
+							}
+							break;
+
 						case OPT_SELECT_FORMAT:
 							if (prompt_option_string(option)) {
 								if (!*tinrc.select_format) {
